#!/usr/bin/env python3
# @generated AUTOGENERATED file. Do not Change!

from dataclasses import dataclass
from datetime import datetime
from gql_client.runtime.datetime_utils import DATETIME_FIELD
from gql_client.runtime.graphql_client import GraphqlClient
from gql_client.runtime.client import OperationException
from gql_client.runtime.reporter import FailedOperationException
from functools import partial
from numbers import Number
from typing import Any, Callable, List, Mapping, Optional, Dict
from time import perf_counter
from dataclasses_json import DataClassJsonMixin

from gql_client.runtime.enum_utils import enum_field
from ..enum.flow_instance_status import FlowInstanceStatus

from ..input.start_flow_input import StartFlowInput


QUERY: List[str] = ["""
mutation StartFlowMutation($input: StartFlowInput!) {
  startFlow(input: $input) {
    id
    status
  }
}

"""]

@dataclass
class StartFlowMutation(DataClassJsonMixin):
    @dataclass
    class StartFlowMutationData(DataClassJsonMixin):
        @dataclass
        class FlowInstance(DataClassJsonMixin):
            id: str
            status: FlowInstanceStatus = enum_field(FlowInstanceStatus)

        startFlow: FlowInstance

    data: StartFlowMutationData

    @classmethod
    # fmt: off
    def execute(cls, client: GraphqlClient, input: StartFlowInput) -> StartFlowMutationData.FlowInstance:
        # fmt: off
        variables: Dict[str, Any] = {"input": input}
        try:
            network_start = perf_counter()
            response_text = client.call(''.join(set(QUERY)), variables=variables)
            decode_start = perf_counter()
            res = cls.from_json(response_text).data
            decode_time = perf_counter() - decode_start
            network_time = decode_start - network_start
            client.reporter.log_successful_operation("StartFlowMutation", variables, network_time, decode_time)
            return res.startFlow
        except OperationException as e:
            raise FailedOperationException(
                client.reporter,
                e.err_msg,
                "StartFlowMutation",
                variables,
            )
